local vm = {w=0,h=0,d1=0,d2=0,d3=0} -- raycaster
local point = {} --raycasting
local fpoint={} --raycasting
local cpoint={} --raycasting
local temppoint = {}
local rendernum = 0
local mathfloor,mathrad,mathtan,mathcos,mathmax = math.floor,math.rad,math.tan,math.cos,math.max

local positive = function(dir,r) --raycasting
	if r >= 0 and r <=90 and dir == "x" then
		return true
	elseif r > 0 and r <=90 and dir == "y" then
		return true
	elseif r > 90 and r <=180 and dir == "x" then
		return false
	elseif r > 90 and r <=180 and dir == "y" then
		return true
	elseif r > 180 and r <=270 and dir == "x" then
		return false
	elseif r > 180 and r <=270 and dir == "y" then
		return false
	elseif r > 270 and r <=361 and dir == "x" then
		return true
	elseif r > 270 and r <=361 and dir == "y" then
		return false
	end
end
local castRay = function(pr,cos_rr,id,screan,world,raycast,pla,utility) --raycasting
	local plax,play = pla.act_x,pla.act_y
	local poixx,poiyx,poixy,poiyy 
	local rad_r = mathrad(pr)
	local tan_r = mathtan(rad_r)
	local nothit = true
	local ya = 0
	local xa = 32/tan_r
	local floorplay = mathfloor(play/32)
	if not positive("y",pr) then
		poiyy = floorplay*32-0.01
		ya=-32
		xa = 0 - xa
	else
		poiyy = floorplay*32+32
		ya=32
	end
	poixy = plax+(poiyy -play) /tan_r

	local xa2 = 0
	local ya2 = 32*tan_r
	local floorplax= mathfloor(plax/32)
	if positive("x",pr) then
		poixx = floorplax*32+32
		xa2=32
	else
		poixx = floorplax*32-0.01
		xa2=-32
		ya2 = 0 - ya2
	end
	poiyx = play+(poixx -plax)* tan_r
	
	local county = 0
	local countx = 0
	local nothity,nothitx = true,true
	while nothity or nothitx do
	    if nothity then
		local floorpoiyy,floorpoixy = mathfloor(poiyy/32),mathfloor(poixy/32)
		if world.map[floorpoiyy] and world.map[floorpoiyy][floorpoixy] and world.map[floorpoiyy][floorpoixy].col == 1 then
			nothity = false
			--low = "y"
		elseif not world.map[floorpoiyy] or (world.map[floorpoiyy] and not world.map[floorpoiyy][floorpoixy]) then
			nothity = false
			--low = "y"
		elseif county == 15 then
			nothity = false
			--low = "y"
		else
			poiyy = poiyy + ya
			poixy = poixy + xa
			county = county + 1
		end
	    end
	    if nothitx then
		local floorpoiyx,floorpoixx = mathfloor(poiyx/32),mathfloor(poixx/32)
		if world.map[floorpoiyx] and world.map[floorpoiyx][floorpoixx] and world.map[floorpoiyx][floorpoixx].col == 1 then
			nothitx = false
			--low = "x"
		elseif not world.map[floorpoiyx] or (world.map[floorpoiyx] and not world.map[floorpoiyx][floorpoixx]) then
			nothitx = false
			--low = "x"
		elseif countx == 15 then
			nothitx = false
			--low = "x"
		else
			poixx = poixx + xa2
			poiyx = poiyx + ya2
			countx = countx + 1
		end
	     end
				
	end	
	local d1,d2 = utility.distance(plax,play,poixy,poiyy)* cos_rr,utility.distance(plax,play,poixx,poiyx)* cos_rr
	if d1 < d2 then -- 
		if county == 15 then
			d1 = 0
		else
			d1 = 32/d1*screan.camdist
		end
			
		return mathfloor(poixy/32),mathfloor(poiyy/32),d1,"y",mathfloor((mathfloor(poixy/32)+1-poixy/32)*64),cos_rr
	else
		if countx == 15 then
			d2 = 0
		else
			d2 = 32/d2*screan.camdist
		end
			
		return mathfloor(poixx/32),mathfloor(poiyx/32),d2,"x",mathfloor((mathfloor(poiyx/32)+1-poiyx/32)*64),cos_rr
	end
end
local of1,of2 = 11.03,19.93 -- 11.03,19.93
return {
	load = function()
		return {vm=vm,point=point,fpoint=fpoint,cpoint=cpoint,temppoint=temppoint,rendernum=rendernum}
	end,
	
	setupfloor = function(raycast,screan,texture) --raycasting
		--isframe = false
		local j = 0
		raycast.fpoint = {}
		raycast.cpoint = {}
		local tempfloorpoint = {}
		local scxcount = 1
		local d = 32/479*screan.camdist + raycast.vm.d1--mathmax(point[1].d,32/479*screan.camdist)
		while screan.h_h-1 + d + 1*j <= screan.h+1 do
			local sc = screan.camdist*(16+raycast.vm.h)/((d+raycast.vm.d2)+j)
			local sc2 = mathfloor(sc*2)
		
			if sc2 > texture.range2-1 then sc2 = texture.range2-1 end
			if sc2 < 0 then sc2 = 0 end
			scxcount = scxcount + 1
			
			if not tempfloorpoint[sc2] then --11.03,19.93
				raycast.fpoint[#raycast.fpoint+1]={i=sc2,sc=32/sc*screan.camdist *of1 ,d=32/sc*screan.camdist/texture.range2 *of2 ,y=screan.h_h + d + 1*j,scx=scxcount,y2=screan.h-(screan.h_h + d + 1*j),l=32/sc*screan.camdist/2}
				scxcount = 1
			end
			tempfloorpoint[sc2] = true
			j=j+1
		end
		d = d-2*raycast.vm.d1
		tempfloorpoint = {}
		scxcount = 1
		j=0
		while screan.h_h-1 + d + 1*j <= screan.h+1 do
			local sc = screan.camdist*(16-raycast.vm.h)/((d-raycast.vm.d2)+j)
			local sc2 = mathfloor(sc*2)
		
			if sc2 > texture.range2-1 then sc2 = texture.range2-1 end
			if sc2 < 0 then sc2 = 0 end
			scxcount = scxcount + 1
			if not tempfloorpoint[sc2] then --11.03,19.93
				raycast.cpoint[#raycast.cpoint+1]={i=sc2,sc=32/sc*screan.camdist *of1 ,d=32/sc*screan.camdist/texture.range2 *of2 ,y=screan.h_h + d + 1*j,scx=scxcount,y2=screan.h-(screan.h_h + d + 1*j),l=32/sc*screan.camdist/2}
				scxcount = 1
			end
			tempfloorpoint[sc2] = true
			j=j+1
		end
	end,
	updateA = function(dt,screan,world,raycast,pla,utility)
		raycast.point = {}
		raycast.temppoint = {} --raycasting
		for i = -50,2*screan.c_w+50 do --raycasting
			local pr = pla.r + (i-screan.c_w)*screan.column
			local pr2 = pr - pla.r
			if pr >= 360 then
				pr = pr - 360
			end
			if pr <= 0 then
				pr = 360 + pr
			end
			if pr2 >= 360 then
				pr2 = pr2 - 360
			end
			if pr2 <= 0 then
				pr2 = 360 + pr2
			end
			local rad_rr = mathrad(pr2)
			local cos_rr = mathcos(rad_rr)
			if i >0 and i <= 2*screan.c_w then
				local x,y,d,dir,c,cos = castRay(pr,cos_rr,i,screan,world,raycast,pla,utility)
				raycast.point[i]={x=x or 1,y=y or 1,d=d or 0,dir=dir or "y",c=c,id=i,r=pr}
			end
			raycast.temppoint[mathfloor(pr*screan.subang)] = {id=i,cos=cos_rr}
		end
	end,
	updateB = function(dt,screan,texture,raycast,pla)
		table.sort(raycast.point,function(a,b) return a.d<b.d end) --raycasting - postprocess
		
		while raycast.point[1].dir == "f" do --raycasting - postprocess
			table.remove(raycast.point,1)
		end 
		local fx, fy, fa, fox, foy = texture.fullfloortodraw:getWidth()/2 , texture.fullfloortodraw:getHeight(), mathrad(-pla.r-90), (pla.act_x-32), (pla.act_y-32) --raycasting - postprocess
		texture.fullfloortodraw:clear()
	
		texture.fullfloortodraw:renderTo(function() --raycasting - postprocess
			love.graphics.setColor(255,255,255)
			love.graphics.draw(texture.fullfloor,fx,fy,fa,1,1,fox,foy)
		end)
		texture.fullceltodraw:clear() --raycasting - postprocess
	
		texture.fullceltodraw:renderTo(function() --raycasting - postprocess
			love.graphics.setColor(255,255,255)
			love.graphics.draw(texture.fullcel,fx,fy,fa,1,1,fox,foy)
		end)
		local d = mathmax(raycast.point[1].d,32/479*screan.camdist) --raycasting - postprocess
		raycast.rendernum = 2*screan.camdist*16/d --raycasting - postprocess
		
	end,
	
}